# Herramientas &arts;

Incluídas con &arts; son una serie de utilidades para controlar y configurar su comportamiento. Necesita estar algo familiarizado con muchas de estas herramientas para usar &arts; de forma efectiva. Esta sección describe cada utilidad y sus opciones para las órdenes.

## &kcontrol;

Cuando ejecuta &arts; bajo &kde;, el &kcontrolcenter; provee un grupo de opciones en el panel de control bajo la categoría Sistema de sonido. Algunas de estas opciones las usa &arts;. Puede también asociar sonidos con varios eventos del administrador de ventanas y &kde; usando el panel Sonidos y multimediaNotificaciones de sistema . Consulte el manual de &kcontrol; para obtener información sobre el manejo de las opciones del panel.

## &artsd;

El acceso a los recursos del hardware de sonido es controlado por &artsd;, el demonio de &arts;. Ésto permite a aplicaciones diferentes enviar solicitudes simultáneas al servidor, donde pueden ser mezcladas y reproducidas. Sin un servidor de sonido centralizado una aplicación usando un dispositivo de sonido podría hacer que otras aplicaciones no lo pudieran usar.

Para usar &arts; tiene que haber una y solo una copia de &artsd; ejecutándose. Se ejecuta normalmente cuando &kde; se inicia si está activado en el panel de &kcontrol; el Servidor de sonido

El programa acepta los siguientes argumentos:

    artsd  -n  -p  -N  -W n   -a método de audio  -r ratio de muestreo  -b bits  -d  -D nombre de dispositivo  -F fragmentos  -S tamaño  -s segundos  -m nombre aplicación    -h -A -v -l nivel

`-r ratio de muestreo`

  Establece el ratio de muestreo a usar.

`-h`

  Muestra la utilización de la orden.

`-n`

  Habilita la transparencia de red.

`-p puerto`

  Establece el puerto TCP a usar (implica `-n`).

`-u`

  Público, sin autentificación (peligroso).

`-d`

  Habilita operaciones en ambas direcciones (full duplex).

`-D nombre de dispositivo`

  Especifica el dispositivo de audio (normalmente `/dev/dsp`).

`-F fragmentos`

  Establece el número de fragmentos.

`-S tamaño`

  Establece el tamaño de los fragmentos, en bytes.

`-s segundos`

  Establece el tiempo de autosuspensión en segundos. El valor cero desactiva la autosuspensión.

`-m nombre applicación`

  Especifica el nombre de la aplicación que se usará para mostrar errores, avisos y mensajes de información. Si está ejecutando KDE puede usar la utilidad artsmessage para ésto.

`-N`

  Incrementa el tamaño de la memoria de intercambio de red a un valor adecuado para ejecutarse sobre una LAN a 10 mbps. Es equivalente a usar la opción -w 5 (ver a continuación).

`-w n`

  Cuando ejecute artsd a través de una conexión de red a otro servidor, normalmente querrá utilizar un tamaño de memoria de intercambio más grande para evitar pérdidas. ARts proporciona aplicaciones con un tamaño de memoria de intercambio mínimo sugerido. Sin esta opción, el tamaño predeterminado está basado en el tamaño del fragmento * número de fragmento. Utilizar esta opción puede incrementar el tamaño predeterminado con un factor n.

`-l nivel`

  Establece el nivel de información: 3 (silencio), 2 (avisos), 1 (información) ó 0 (depuración).

`-v`

  Muestra el nivel de la versión.

En la mayoría de los casos con ejecutar &artsd; será suficiente.

## &artswrapper;

Para proveer una buena respuesta en tiempo real, &artsd; se ejecuta normalmente como un proceso en tiempo real (en plataformas en las que se soportan prioridades en tiempo real). Ésto requiere permisos de root, por lo que para minimizar las implicaciones de seguridad, &artsd; puede iniciarse usando un pequeño programa &artswrapper; el cual simplemente establece prioridad en tiempo real (ejecutándose como root) y después arranca &artsd; como un usuario no root.

Si hace artswrapper SUID root, probablemente mejorará la calidad de su reproductor de audio reduciendo los saltos en la música. Sin embargo, también incrementará el riesgo de fallos en el código o de que un usuario malicioso pueda colgar o perjudicar su máquina. Además, en las máquinas multiusuario, priorizar el audio de alta calidad puede dar como resultado un menor rendimiento para los usuarios que intentan hacer «productivo» el uso de la máquina.

## &artsshell;

El orden &artsshell; se ideó como una utilidad para realizar varias funciones relacionadas con el servidor de sonido. Se espera que la utilidad se extienda con nuevas órdenes en el futuro (consulte los comentarios del código fuente para ver algunas ideas).

La orden tiene el siguiente formato:

    artsshell  suspendstatus terminate autosuspend segundos networkbuffers n volume [volumen] stereoeffect opciones   -h -q

artsshell [opciones] orden [opciones de la orden]

Están soportadas las siguientes opciones:

`-q`

  Suprime todas las salidas.

`-h`

  Muestra la utilización de la orden.

Están soportadas las siguientes órdenes:

`suspend`

  Suspende el servidor de sonido.

`status`

  Muestra información del estado del servidor de sonido.

`terminate`

  Finalizar el servidor de sonido. Ésto puede confundir y/o colgar aplicaciones que se estén usando en ese momento.

`autosuspend` `segundos`

  Establece el tiempo de autosuspensión en el número especificado de segundos. El servidor de sonido se suspenderá asimismo si está ocioso durante ese periodo de tiempo. El valor cero desactiva la autosuspensión.

`networkbuffers` `n`

  Establece el tamaño de la memoria de intercambio de red a un factor `n` veces el tamaño predeterminado.

`volume` [volumen]

  Establece el nivel de volumen para la salida de audio del servidor de sonido. El argumento volumen es un valor de coma flotante. Si no se añaden argumentos se muestra el volumen actual.

`stereoeffect list`

  Lista todos los módulos de efectos estéreo disponibles.

`stereoeffect insert [top|bottom]` nombre

  Inserta un efecto estéreo en la pila de efectos estéreo. Devuelve un identificador que puede usarse después para borrarlo. Puede instalarse en la parte superior o en la inferior (predeterminado).

`stereoeffect remove` id

  Quita el efecto estéreo con identificador id de la pila de efectos.

## artsplay

La orden artsplay es una utilidad para reproducir un archivo de sonido. Acepta un solo argumento correspondiente al nombre del archivo de sonido que será enviado al servidor de sonido para ser reproducido. El archivo de sonido puede ser de alguno de los tipos de archivo de sonido comunes `wav` o `au`. Ésta utilidad es buena para comprobar si el servidor de sonido está funcionando. Ejecutando dos órdenes en paralelo o en una rápida sucesión puede demostrar cómo el servidor de sonido combina más de una fuente de sonido.

## artsdsp

El servidor de sonido solo soporta aplicaciones que soporten &arts;. Algunas aplicaciones heredadas querrán acceder al dispositivo de sonido directamente. La orden &artsdsp; proporciona una solución provisional que permite a la mayor parte de estas aplicaciones ejecutarse sin cambios.

Cuando una aplicación se ejecuta bajo &artsdsp; todos los accesos al dispositivo de audio `/dev/dsp` son interceptados y mapeados dentro de las llamadas al API de &arts;. A pesar de que la emulación del dispositivo no es muy buena, muchas aplicaciones funcionan de este modo, aunque con alguna degradación en la ejecución y la latencia.

La orden &artsdsp; sigue el siguiente formato:

artsdsp [opciones] argumentos de la aplicación

Se reconocen las siguientes opciones:

`-h`, `--help`

  Muestra un mensaje de ayuda.

`-n` `--name` = nombre

  Usa nombre para identificar un reproductor en `artsd`.

`-m` `--mmap`

  Emula el mapeo de memoria (&eg; para Quake).

`-v` `--verbose`

  Muestra los parámetros.

Una llamada típica es:

``artsdsp` `-v` `-m` `realplay cancion.mp3``

Algunas aplicaciones funcionan mejor con la opcion `--mmap`. No todas las características del dispositivo de sonido son totalmente emuladas, pero muchas aplicaciones deberían funcionar. Si encuentra una que no lo hace, envíe un detallado informe del fallo y los desarrolladores intentarán arreglarlo. De nuevo, recuerde que ésta es una solución provisional y algo fea. La mejor solución es añadir soporte nativo para &arts; en las aplicaciones. Si su aplicación favorita de sonido no tiene soporte para &arts; pregunte a sus desarrolladores para proveérselo.

## artscat

Es una simple utilidad para enviar datos de audio puros al servidor de sonido. Necesita especificar el formato de los datos (ratio de muestreo, tamaño de muestra y número de canales). Probablemente sea una utilidad que no usará a menudo, pero puede ser útil para hacer pruebas. La sintaxis de la orden es:

artscat [ opciones ] [ nombre de archivo ]

Si no se especifica un nombre de archivo, lee la entrada estándar. Están soportadas las siguientes opciones:

`-r` `ratio de muestreo`

  Establece el ratio de muestreo a usar.

`-b` `bits`

  Establece el tamaño de muestra a usar (8 o 16).

`-c` `canales`

  Establece el número de canales (1 ó 2).

`-h`

  Muestra el uso de la orden y sale.

## &artscontrol;

Ésta es una aplicación gráfica para realizar una serie de tareas relacionadas con el servidor de sonido. La ventana predeterminada muestra dos indicadores de volumen y un deslizador para controlar este volumen. Desde el menú Ver puede seleccionar otras funciones:

Campo FFT

  Abre una ventana que muestra una pantalla con un analizador de espectro en tiempo real.

Administrador de audio

  Muestra las fuentes de sonido activas y le permite conectarlas a alguno de los buses disponibles.

Estado de aRTs

  Muestra si el servidor de sonido se está ejecutando y si trabaja en tiempo real. Indica si el servidor será autosuspendido y permite suspenderlo automáticamente.

Administrador midi

  Muestra entradas y salidas &MIDI; activas y le permite realizar conexiones [PENDIENTE: ¿No funciona todavía? Necesita más detalles].

FreeVerb

  Conecta el efecto de reverberación FreeVerb a la pila de efectos de salida de &arts; y le permite controlar los parámetros del efecto gráficamente.

Pantalla de volumen estilo led

  Cambia el indicador de volumen de la ventana principal para usar una pantalla con formato de LED en lugar de una barra de progreso.

## artsc-config

Ésta es una utilidad para ayudar a los desarrolladores utilizando el API C de &arts;. Da como resultado la salida apropiada para el compilador así como las opciones necesarias cuando se compila y enlaza código con &arts;. Se pretende que sea utilizado sin archivos para ayudar a la portabilidad. La orden acepta tres opciones:

`--cflags`

  Muestra los indicadores del compilador cuando se compila con la API C de &arts;.

`--libs`

  Muestra los indicadores del enlazador necesarios cuando se enlaza con la API C de &arts;.

--version

  Muestra la versión de la orden `artsc-config`.

La respuesta usual de la orden se muestra a continuación:

    % artsc-config --cflags
    -I/usr/local/kde2/include/artsc
    % artsc-config --libs
    -L/usr/local/kde2/lib -ldl -lartsc -DPIC -fPIC -lpthread
    % artsc-config --version
    0.9.5

Puede usar esta utilidad para crear un archivo utilizando una regla como:

    artsc: artsc.c
            gcc `artsc-config --cflags` -o artsc artsc.c `artsc-config --libs`

## &mcopidl;

La utilidad &mcopidl; es el compilador de archivos &IDL; para &MCOP;, el Protocolo de Comunicación Multimedia usado por &arts;. Las interfaces en &arts; se definen en &IDL;, un lenguaje independiente, Lenguaje de Definición de Interfaces. La utilidad &mcopidl; acepta un archivo &IDL; como entrada y genera archivos cabecera y fuente en C++ para una clase, implementando la interfaz. La orden utiliza la siguiente sintaxis:

mcopidl [ opciones ] nombrearchivo

Las opciones válidas son:

`-I` `directorio`

  Busca cabeceras en el `directorio`.

`-e` `nombre`

  Excluye el nombre de una estructura, interfaz o tipo enum durante la generación del código.

`-t`

  También crea archivos `.mcoptype`/`.mcopclass` con información de tipo para el archivo &IDL;.

Puede encontrar más información sobre &MCOP; e &IDL; en la sección Interfaces e &IDL;.